VERSION 5.00
Object = "{B6C10482-FB89-11D4-93C9-006008A7EED4}#1.0#0"; "TeeChart5.ocx"
Begin VB.Form TestTChart 
   Caption         =   "Test TChart"
   ClientHeight    =   8850
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11475
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   8850
   ScaleWidth      =   11475
   StartUpPosition =   3  'Windows Default
   Begin TeeChart.TChart TChart1 
      Height          =   8655
      Left            =   120
      OleObjectBlob   =   "Form1.frx":0000
      TabIndex        =   0
      Top             =   120
      Width           =   6015
   End
   Begin VB.TextBox Text2 
      Height          =   3015
      Left            =   6600
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Text            =   "Form1.frx":00B1
      Top             =   3360
      Width           =   4455
   End
   Begin VB.TextBox Text1 
      Height          =   3015
      Left            =   6600
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Text            =   "Form1.frx":00CB
      Top             =   120
      Width           =   4455
   End
End
Attribute VB_Name = "TestTChart"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_oAxis                         As IAxes

Private Const NUM_OF_LINES              As Long = 300
Private Const NUM_OF_COLUMNS            As Long = 3

Private Sub SetTChartProperties()

    Dim m_lCurrentRowHeight     As Long
    
    With TChart1
        
        .top = 0
        .left = 0
        
        .Enabled = True
        
        .Environment.MouseWheelScroll = False
        .Header.Visible = False
        
        .Panel.MarginLeft = 0
        .Panel.MarginBottom = 0
        .Panel.MarginTop = 0
        .Panel.MarginRight = 0
        
        .Repaint
        
        Set m_oAxis = .Axis
        
        m_oAxis.right.Visible = True
        m_oAxis.left.Visible = True
        m_oAxis.top.Visible = False
        m_oAxis.Bottom.Visible = False
        
    End With
              
    m_oAxis.left.Automatic = False
    
    '// = 20 pixels. This is arbitrary text size + space for the line (from the top and bottom of the line)
    m_lCurrentRowHeight = 300

    m_oAxis.Bottom.SetMinMax 0, NUM_OF_COLUMNS
    m_oAxis.left.SetMinMax 1, NUM_OF_LINES
    
    TChart1.Height = m_lCurrentRowHeight * (m_oAxis.left.Maximum + 1)
    
    Debug.Print TChart1.Height
    
End Sub

Private Sub DrawTChartGrid()

    Dim lRow            As Long
    Dim lPrevTop        As Double
    Dim lCurrTop        As Double
    Dim tRect           As RECT
    Dim l As Long
    
    tRect.right = 30
    tRect.left = 0
    
    lPrevTop = 0
    
    With TChart1.Canvas
        
        For lRow = 1 To m_oAxis.left.Maximum
            'tRect.top = m_oAxis.left.CalcYPosValue(lRow)
            'tRect.Bottom = m_oAxis.left.CalcYPosValue(lRow + 1)
            lCurrTop = m_oAxis.left.CalcYPosValue(lRow)
                        
            '// Print the results to text boxes
            Text1.Text = Text1.Text & vbNewLine & "Top of current rect: " & lCurrTop & _
                                     vbNewLine & "height : " & lCurrTop - lPrevTop
                                     
            If lCurrTop - lPrevTop <> 20 Then
                Text2.Text = Text2.Text & vbNewLine & "Row : " & lRow _
                                        & vbNewLine & "Height : " & lCurrTop - lPrevTop & " => " & m_oAxis.left.CalcYPosValue(lRow + 1) - m_oAxis.left.CalcYPosValue(lRow)
            End If
            
            l = l + lCurrTop - lPrevTop
            lPrevTop = lCurrTop
            
            Call .Line(30, m_oAxis.left.CalcYPosValue(lRow), TChart1.Width / Screen.TwipsPerPixelX, m_oAxis.left.CalcYPosValue(lRow))
        Next lRow
        
    End With
    
    MsgBox l
    
End Sub

Private Sub SetTChartFont()

    With TChart1
    
        .Header.Font.Size = 10
                    
        .Axis.left.Labels.Font.Size = 10
        .Axis.left.Labels.Font.Name = "Arial"

        .Axis.right.Labels.Font.Size = 10
        .Axis.right.Labels.Font.Name = "Arial"

        .Axis.Bottom.Labels.Font.Size = 10
        .Axis.Bottom.Labels.Font.Name = "Arial"

        .Axis.top.Labels.Font.Size = 10
        .Axis.top.Labels.Font.Name = "Arial"
        
        .Legend.Font.Size = 10
        .Legend.Font.Name = "Arial"
        
        .Canvas.Font.Size = 10
        .Canvas.Font.Name = "Arial"
        
        .Axis.left.Title.Font.Size = 10
        .Axis.left.Title.Font.Name = "Arial"

        .Axis.right.Title.Font.Size = 10
        .Axis.right.Title.Font.Name = "Arial"

        .Axis.Bottom.Title.Font.Size = 10
        .Axis.Bottom.Title.Font.Name = "Arial"

        .Axis.top.Title.Font.Size = 10
        .Axis.top.Title.Font.Name = "Arial"
    
    End With


End Sub

Private Sub Form_Load()
    Text1.Text = "Calculations of TChart rectangle:"
    Text2.Text = "The inconsistent lines:"
    
    SetTChartFont
    SetTChartProperties
    
End Sub

Private Sub TChart1_OnAfterDraw()
    DrawTChartGrid
End Sub
